#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Aug  9 14:17:22 2023
@author: righi
"""
from math import *
import numpy as np
import matplotlib.pyplot as plt
def f(x): return x*np.exp(x)-1
def df(x): return (1.0+x)*np.exp(x)
x = np.zeros(100, float)
tol=1E-4
x[0]=0.0
k=0
for i in range(1,30,1):
  
  x[i]=x[i-1]-f(x[i-1]) /df(x[i-1])
  print (f"{i:2d}"," ",f"{x[i-1]:2.8f}"," ",f"{f(x[i-1]):2.8f}")
  if np.abs(x[i]-x[i-1]) < tol:
    k=i  
    break
print ("iti=",k,"x=",x[k])
x1=x[k]
#pour tracer la courbe
x = np.linspace(0, 1, 30)
y = x*np.exp(x)-1
fig, ax = plt.subplots()
ax.plot(x, y)
plt.title('Newton-Raphson Method')

plt.legend([ r'$xe^{x} -1$'])

plt.ylabel('f (x)')
plt.xlabel('x')
plt.annotate(r"$ x_{sol} $="+f"{x1:.5f}", xy=(x1, 0),xytext=(0.2,1.0),arrowprops=dict(facecolor='Red',arrowstyle='->'))
plt.grid('on',color='r', linestyle='-.',linewidth=0.5)
plt.show()

#raw_ input("Press return to exit")
